<?php
/* Preset FCG setting*/
/* Rename /includes/options-init-preset.php to options-init.php to active the setting */
if(file_exists(TEMPLATEPATH."/includes/options-init.php")) require_once TEMPLATEPATH."/includes/options-init.php";

/* Designed by ThemesPanel.com */
$tpinfo['themename']='Aqua Blue ';
$tpinfo['prefix']='themespanel'; 		//for options. e.g. all ThemesPanel themes should use "ThemesPanel" for general options (feed url, twitter id, analytics)
$tpinfo['tb_prefix']='themespanel_ab';//for options. theme base prefix, e.g. styles. (aq=Aqua Blue)

/* Add default posts and comments RSS feed links to head */
add_theme_support('automatic-feed-links');

/* This theme uses wp_nav_menu() in one location. */
register_nav_menus( array(
	'primary' => __( 'Primary Navigation' ),
) );

function twentyten_page_menu_args( $args ) {
	$args['show_home'] = true;
	return $args;
}
add_filter( 'wp_page_menu_args', 'twentyten_page_menu_args' );

if(function_exists('register_sidebar')){
	register_sidebar(array(
		'name' =>'Sidebar 1',
		'description' => 'Primary Widget Area',
		'before_widget' => '<li id="%1$s" class="widget %2$s">',
		'after_widget' => '</li>',
		'before_title' => '<h4>',
		'after_title' => '</h4>')
	);
	function unregister_problem_widgets() {
		unregister_sidebar_widget('search');
	}
	//add_action('widgets_init','unregister_problem_widgets');
}

function my_fields($fields) {
	$commenter = wp_get_current_commenter();
	$req = get_option( 'require_name_email' );
	$aria_req = ( $req ? " aria-required='true'" : '' );
	$fields = array( 

		'author' => '<p class="comment-form-author">' .
		            '<input id="author" name="author" type="text" value="' . esc_attr( $commenter['comment_author'] ) . '" size="22"' . $aria_req . '/>' . '<label for="author">' . __( ' Name' ) . '</label> ' . ( $req ? '<span class="required">(required)</span>' : '' ) . '</p>',

		'email'  => '<p class="comment-form-email">'.
		            '<input id="email" name="email" type="text" value="' . esc_attr(  $commenter['comment_author_email'] ) . '" size="22"' . $aria_req . '/>' . '<label for="email">' . __( ' E-Mail' ) . '</label> ' . ( $req ? '<span class="required">(will not be published, required)</span>' : '' ) . '</p>',

		'url'    => '<p class="comment-form-url">' .
		            '<input id="url" name="url" type="text" value="' . esc_attr( $commenter['comment_author_url'] ) . '" size="22" />' . '<label for="url">' . __( ' Website' ) . '</label>' . ( $req ? '<span class="optional">(optional)</span>' : '' ) .  '</p>',
					
	);
return $fields;
}
add_filter('comment_form_default_fields','my_fields');

function my_defaults($defaults) {
	$defaults['comment_field'] = '<p class="comment-form-comment"><label for="comment">' . '<p class="form-allowed-tags">' . sprintf( __( '<strong><abbr title="HyperText Markup Language">HTML</abbr></strong>: You may use these tags and attributes: %s' ), '<small>' . allowed_tags() . '</small>' ) . '</p>' . '</label><textarea id="comment" name="comment" cols="45" rows="10" aria-required="true"></textarea></p>';
	$defaults['comment_notes_before'] = '';
	$defaults['comment_notes_after'] = '';
	$defaults['label_submit'] = 'Submit';

return $defaults;
}
add_filter('comment_form_defaults', 'my_defaults');

include(TEMPLATEPATH.'/includes/theme-options.php');
include(TEMPLATEPATH.'/includes/theme-setup.php');
include(TEMPLATEPATH.'/includes/admin-interface.php');
include(TEMPLATEPATH.'/includes/admin-widgets.php');
include(TEMPLATEPATH.'/includes/theme-functions.php');
?>